.386
.model flat,stdcall
option casemap:none

include LVCombo.inc

; this is where the magic happens. add this in then add few bits and pieces for WM_NOTIFY:NM_CLICK and then call the appropriate function for
; dynamically adding a Dropdownlist combo - ListViewDropDownListMode, or a Dropdown combo with an editbox - ListViewDropDownMode
; then call your own functions for setting the combo data. examples below to show how to decide what content to show for a particular column in our listview
include listview.asm 

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL lvhi:LVHITTESTINFO
    LOCAL lvi:LV_ITEM
    LOCAL rect:RECT
    LOCAL hwndLV:DWORD

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd

		Invoke InitLV, hWin ; startup our listview
		Invoke ListViewDisableColumnResizing, hLV ; disable column resizing in listview for our comboboxes etc to look ok
		Invoke LoadLV, hWin ; load some data into listview
		
	
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.elseif eax==IDC_EXIT
		    invoke SendMessage,hWin,WM_CLOSE,0,0
		.endif
    
    .elseif eax==WM_NOTIFY
		mov ecx, lParam
		mov eax, (NMHDR PTR [ecx]).idFrom
		.IF eax == IDC_LV
		    
    		mov eax, (NMHDR PTR [ecx]).code
    		mov ebx, (NMHDR PTR [ecx]).hwndFrom
    		mov hwndLV, ebx
            .IF eax == NM_CLICK
                
    			invoke GetCursorPos, addr lvhi.pt
    			invoke ScreenToClient, hwndLV, addr lvhi.pt
    			invoke SendMessage,hwndLV,LVM_SUBITEMHITTEST,0, Addr lvhi ; returns the column and item that was clicked in lvhi
    			
    			Invoke SendMessage, hwndLV, LVM_GETITEMCOUNT, 0, 0
    			.IF (eax > lvhi.iItem)
    			    .IF (lvhi.iSubItem == 0) ; superpower column
    			        Invoke ListViewDropDownMode, hwndLV, IDC_CBO_DD_SUPER_POWER, lvhi.iItem, lvhi.iSubItem ; create in place dropdown (with edit) combo
    			        mov hCboDD, eax
    			        Invoke ListViewDropDownContent, hwndLV, IDC_CBO_DD_SUPER_POWER, lvhi.iItem, lvhi.iSubItem ; set the combobox contents
    			        ;Invoke SendMessage, hCboDD, CBM_CBEDITSETCASE, CBEC_UPPERCASE, 0
    			        Invoke SendMessage, hCboDD, CBM_CBEDITSETFORMAT, CBEF_ALPHABET + CBEF_SPACE, 0 ;+ CBEM_NUMERIC + CBEM_NUMERIC_SYMBOLS, 0
    			        Invoke SendMessage, hCboDD, CB_LIMITTEXT, 8, 0
    			        
    			    .ELSEIF (lvhi.iSubItem == 1) ; student name
    			        ; do nothing with student name - disabled on purpose, you can use LVN_BEGINLABELEDIT etc if you wish or perhaps ill add in a dynamic Editbox
    			        ; for the next version :D
    			        ; 03/03/2012 NOTE - this is the next version, so ive added the dynamic editbox when user clicks on this cell.
    			        Invoke ListViewEditBoxMode, hwndLV, IDC_EDIT, lvhi.iItem, lvhi.iSubItem ;
    			        
    			    .ELSEIF (lvhi.iSubItem == 2) ; age
    			        Invoke ListViewDropDownListMode, hwndLV, IDC_CBO_DDL_AGE, lvhi.iItem, lvhi.iSubItem ; create in place dropdownlist combo
    			        Invoke ListViewDropDownListContent, hwndLV, IDC_CBO_DDL_AGE, lvhi.iItem, lvhi.iSubItem ; set the combobox contents
    			       
    			    
    			    .ELSEIF (lvhi.iSubItem == 3) ; sex
                        Invoke ListViewDropDownListMode, hwndLV, IDC_CBO_DDL_SEX, lvhi.iItem, lvhi.iSubItem ; create in place dropdownlist combo
    			        Invoke ListViewDropDownListContent, hwndLV, IDC_CBO_DDL_SEX, lvhi.iItem, lvhi.iSubItem ; set the combobox contents

    			    .ELSEIF (lvhi.iSubItem == 4) ; classroom
    			        Invoke ListViewDropDownMode, hwndLV, IDC_CBO_DD_CLASSROOM, lvhi.iItem, lvhi.iSubItem ; create in place dropdown (with edit) combo
    			        Invoke ListViewDropDownContent, hwndLV, IDC_CBO_DD_CLASSROOM, lvhi.iItem, lvhi.iSubItem ; set the combobox contents    			    			    

                    .ELSEIF (lvhi.iSubItem == 5) ; teacher
    			        Invoke ListViewDropDownListMode, hwndLV, IDC_CBO_DDL_TEACHER, lvhi.iItem, lvhi.iSubItem ; create in place dropdownlist combo
    			        Invoke ListViewDropDownListContent, hwndLV, IDC_CBO_DDL_TEACHER, lvhi.iItem, lvhi.iSubItem ; set the combobox contents                           

                    .ELSEIF (lvhi.iSubItem == 6) ; progress
    			        Invoke ListViewDropDownMode, hwndLV, IDC_CBO_DD_PROGRESS, lvhi.iItem, lvhi.iSubItem ; create in place dropdown (with edit) combo
    			        Invoke ListViewDropDownContent, hwndLV, IDC_CBO_DD_PROGRESS, lvhi.iItem, lvhi.iSubItem ; set the combobox contents
    			    .ENDIF       
    			.ENDIF

   
            .ENDIF
        .ENDIF    
		
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp


;-------------------------------------------------------------------------------------
; Initializes the Listview
;-------------------------------------------------------------------------------------
InitLV   PROC    hWin:DWORD
    LOCAL LVColumn:LV_COLUMN; Lisview Column Structure
    
    Invoke GetDlgItem, hWin, IDC_LV
	mov hLV, eax

	; Setup extended styles like gridlines
	mov eax, LVS_EX_GRIDLINES or LVS_EX_INFOTIP or LVS_EX_FULLROWSELECT  ; Fullrowselect needed for hittest of subitem 0 - otherwise it only works with you click on text in first col
	Invoke SendMessage, hLV, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax 

	; First Column
	mov LVColumn.imask, LVCF_TEXT or LVCF_WIDTH
	mov LVColumn.pszText, CTEXT("Superpower")
	;mov LVColumn.fmt, LVCFMT_LEFT
	mov LVColumn.lx, 130
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 0, addr LVColumn  

	; Second Column
	or LVColumn.imask, LVCF_TEXT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Student Name")
	mov LVColumn.lx, 130
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 1, addr LVColumn 

	; Third Column
	or LVColumn.imask, LVCF_TEXT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Age")
	mov LVColumn.lx, 60
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 2, addr LVColumn 
    
	; Fourth Column
	or LVColumn.imask, LVCF_TEXT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Sex")
	mov LVColumn.lx, 60
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 3, addr LVColumn
	
	; Fifth Column
	or LVColumn.imask, LVCF_TEXT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Classroom")
	mov LVColumn.lx, 100
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 4, addr LVColumn 	
	
	; Sixth Column
	or LVColumn.imask, LVCF_TEXT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Teacher")
	mov LVColumn.lx, 130
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 5, addr LVColumn 	

	; Seventh Column
	or LVColumn.imask, LVCF_TEXT
	;mov LVColumn.fmt, LVCFMT_RIGHT
	mov LVColumn.pszText, CTEXT("Progress")
	mov LVColumn.lx, 300
	Invoke SendMessage, hLV, LVM_INSERTCOLUMN, 6, addr LVColumn 
	
	Invoke ListViewSubClass, hLV, Addr LVSubClass
	  
    ret

InitLV endp

;-------------------------------------------------------------------------------------
; Loads the Listview with data
;-------------------------------------------------------------------------------------
LoadLV    PROC    hWin:DWORD

    ; Load up data in listview, each students details
    Invoke ListViewInsertItem, hLV, 0, CTEXT("Levitation"), 0
    Invoke ListViewInsertSubItem, hLV, 0, 1, CTEXT("Bob Smith")
    Invoke ListViewInsertSubItem, hLV, 0, 2, CTEXT("12")
    Invoke ListViewInsertSubItem, hLV, 0, 3, CTEXT("M")
    Invoke ListViewInsertSubItem, hLV, 0, 4, CTEXT("Hut 4")
    Invoke ListViewInsertSubItem, hLV, 0, 5, CTEXT("Mr. Jones")
    Invoke ListViewInsertSubItem, hLV, 0, 6, CTEXT("Needs more work")
    
    Invoke ListViewInsertItem, hLV, 1, CTEXT("Lightning Hands"), 0
    Invoke ListViewInsertSubItem, hLV, 1, 1, CTEXT("Sally Jamison")
    Invoke ListViewInsertSubItem, hLV, 1, 2, CTEXT("11")
    Invoke ListViewInsertSubItem, hLV, 1, 3, CTEXT("F")
    Invoke ListViewInsertSubItem, hLV, 1, 4, CTEXT("Room 6")
    Invoke ListViewInsertSubItem, hLV, 1, 5, CTEXT("Mrs. Abignail")
    Invoke ListViewInsertSubItem, hLV, 1, 6, CTEXT("Destined to rule the world")
    
    Invoke ListViewInsertItem, hLV, 2, CTEXT("Fire-breathing"), 0
    Invoke ListViewInsertSubItem, hLV, 2, 1, CTEXT("Henry Sellers")
    Invoke ListViewInsertSubItem, hLV, 2, 2, CTEXT("10")
    Invoke ListViewInsertSubItem, hLV, 2, 3, CTEXT("M")
    Invoke ListViewInsertSubItem, hLV, 2, 4, CTEXT("Main Hall")
    Invoke ListViewInsertSubItem, hLV, 2, 5, CTEXT("Mr. Blue")
    Invoke ListViewInsertSubItem, hLV, 2, 6, CTEXT("Potion X112 working well")
    
    Invoke ListViewInsertItem, hLV, 3, CTEXT("Telepathy"), 0
    Invoke ListViewInsertSubItem, hLV, 3, 1, CTEXT("Kevin Arnold")
    Invoke ListViewInsertSubItem, hLV, 3, 2, CTEXT("13")
    Invoke ListViewInsertSubItem, hLV, 3, 3, CTEXT("M")
    Invoke ListViewInsertSubItem, hLV, 3, 4, CTEXT("Room 8")
    Invoke ListViewInsertSubItem, hLV, 3, 5, CTEXT("Mrs. Abignail")
    Invoke ListViewInsertSubItem, hLV, 3, 6, CTEXT("Progress is fine")

    Invoke ListViewInsertItem, hLV, 4, CTEXT("X-RAY Vision"), 0
    Invoke ListViewInsertSubItem, hLV, 4, 1, CTEXT("Jessica Orange")
    Invoke ListViewInsertSubItem, hLV, 4, 2, CTEXT("12")
    Invoke ListViewInsertSubItem, hLV, 4, 3, CTEXT("F")
    Invoke ListViewInsertSubItem, hLV, 4, 4, CTEXT("Hut 2")
    Invoke ListViewInsertSubItem, hLV, 4, 5, CTEXT("Mr. Jones")
    Invoke ListViewInsertSubItem, hLV, 4, 6, CTEXT("Needs more work")    

    Invoke ListViewInsertItem, hLV, 5, CTEXT("Telepathy"), 0
    Invoke ListViewInsertSubItem, hLV, 5, 1, CTEXT("Little Timmy")
    Invoke ListViewInsertSubItem, hLV, 5, 2, CTEXT(" 8")
    Invoke ListViewInsertSubItem, hLV, 5, 3, CTEXT("M")
    Invoke ListViewInsertSubItem, hLV, 5, 4, CTEXT("Room 6")
    Invoke ListViewInsertSubItem, hLV, 5, 5, CTEXT("Mrs. Abignail")
    Invoke ListViewInsertSubItem, hLV, 5, 6, CTEXT("Potion X112 working well") 
       
    Invoke ListViewInsertItem, hLV, 6, CTEXT("Empathy"), 0
    Invoke ListViewInsertSubItem, hLV, 6, 1, CTEXT("Joanna Stapleton")
    Invoke ListViewInsertSubItem, hLV, 6, 2, CTEXT("11")
    Invoke ListViewInsertSubItem, hLV, 6, 3, CTEXT("F")
    Invoke ListViewInsertSubItem, hLV, 6, 4, CTEXT("Art Room")
    Invoke ListViewInsertSubItem, hLV, 6, 5, CTEXT("Dr. Octavious")
    Invoke ListViewInsertSubItem, hLV, 6, 6, CTEXT("Needs more work")   
    
    Invoke ListViewInsertItem, hLV, 7, CTEXT("Demon Eyes"), 0
    Invoke ListViewInsertSubItem, hLV, 7, 1, CTEXT("Kurt Englund")
    Invoke ListViewInsertSubItem, hLV, 7, 2, CTEXT("14")
    Invoke ListViewInsertSubItem, hLV, 7, 3, CTEXT("M")
    Invoke ListViewInsertSubItem, hLV, 7, 4, CTEXT("Annex B")
    Invoke ListViewInsertSubItem, hLV, 7, 5, CTEXT("Dr. Samantha")
    Invoke ListViewInsertSubItem, hLV, 7, 6, CTEXT("Progress is fine")             
   
    ret
LoadLV    ENDP





;-------------------------------------------------------------------------------------
; Populate combobox content of the in place editing of our listview subitem
;
; hListview param refers to the listview control you are using
;
; ComboDDResID param, if used, is for deciding which combobox content to load
; which means you can have many DropDown ComboBoxes, and depending on the one
; selected to display you can have different content
;
; iItem and iSubItem can also be used for conditional branching if desired, or
; as a way to get the text of the listview item to search for in the combobox
; once it is activiated. 
;-------------------------------------------------------------------------------------
ListViewDropDownListContent   PROC    hListview:DWORD, ComboDDLResID:DWORD, iItem:DWORD, iSubItem:DWORD
    LOCAL szTextBuffer[MAX_PATH]:byte
    LOCAL hCbo:DWORD
    
    Invoke GetDlgItem, hListview, ComboDDLResID
    mov hCbo, eax
    
    .IF ComboDDLResID == IDC_CBO_DDL_AGE
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT(" 6")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT(" 7")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT(" 8")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT(" 9")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("10")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("11")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("12")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("13")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("14")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("15")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("16")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("17")	
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("18")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("19")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("20")
    
    .ELSEIF ComboDDLResID == IDC_CBO_DDL_SEX
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("M")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("F")
    
    .ELSEIF ComboDDLResID == IDC_CBO_DDL_TEACHER     
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mr. Jones")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Dr. Olivia")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mrs. Abignail")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mr. Blue")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mrs. Harris")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Dr. Octavious")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mr. Westerfield")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Dr. Simons")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mrs. Claire")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mr. Herman")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Dr. Samantha")
    .ENDIF
    
    ; Get item text, and try and find it in our dropdownlist combobox
    Invoke ListViewGetItemText, hListview, iItem, iSubItem, Addr szTextBuffer, SIZEOF szTextBuffer
    Invoke SendMessage, hCbo, CB_FINDSTRINGEXACT, -1, Addr szTextBuffer
    .IF eax != CB_ERR
        Invoke SendMessage, hCbo, CB_SETCURSEL, eax, 0
    .ENDIF    
    ret

ListViewDropDownListContent endp



;-------------------------------------------------------------------------------------
; Populate combobox content of the in place editing of our listview subitem
;
; hWin param refers to the listview control you are using
;
; ComboDDResID param, if used, is for deciding which combobox content to load
; which means you can have many DropDown ComboBoxes, and depending on the one
; selected to display you can have different content
;
; iItem and iSubItem can also be used for conditional branching if desired, or
; as a way to get the text of the listview item to search for in the combobox
; once it is activiated. 
;-------------------------------------------------------------------------------------
ListViewDropDownContent   PROC    hListview:DWORD, ComboDDResID:DWORD, iItem:DWORD, iSubItem:DWORD
    LOCAL szTextBuffer[MAX_PATH]:byte
    LOCAL hCbo:DWORD
    
    Invoke GetDlgItem, hListview, ComboDDResID
    mov hCbo, eax

    .IF ComboDDResID == IDC_CBO_DD_SUPER_POWER
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Levitation")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Whirlwind")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Demon Eyes")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Lightning Hands")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Super Agility")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Fire-breathing")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("X-RAY Vision")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Remote Viewing")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Telepathy")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Mental Projection")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Shapeshift")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Concussive Force")	
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Unbreakable")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Regeneration")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Flight")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Super Hearing")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Invulnerability")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Siren Call")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Phase Shift")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Invisibility")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Healing")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Time Stop")
    	
    .ELSEIF ComboDDResID == IDC_CBO_DD_CLASSROOM
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Hut 1")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Hut 2")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Hut 3")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Hut 4")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 1")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 2")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 3")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 4")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 5")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 6")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 7")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 8")	
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 9")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Room 10")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Annex A")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Annex B")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Main Hall")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Study Hall")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Library")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Art Room")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Music Room")
        
    .ELSEIF ComboDDResID == IDC_CBO_DD_PROGRESS
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Subject failed")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Needs more work")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Works well with others")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Needs individual attention")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Advise we terminate subject")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Caution: Extremely dangerous!")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Caution: Must be sedated at all times")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Preliminary research started")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Potion X112 working well")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Potion X110 working well")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Progress is fine")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Progress is good")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Progress is exceptional")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Destined to rule the world")	
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Subject deceased")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Subject AWOL")
    	Invoke SendMessage, hCbo, CB_ADDSTRING, 0, CTEXT("Kill on sight")
    .ENDIF
    
    ; Get the text of the currently selected listview item/subitem
    Invoke ListViewGetItemText, hListview, iItem, iSubItem, Addr szTextBuffer, SIZEOF szTextBuffer

    ; Search for this text item in our combobox
    Invoke SendMessage, hCbo, CB_FINDSTRINGEXACT, -1, Addr szTextBuffer
    .IF eax != CB_ERR
        Invoke SendMessage, hCbo, CB_SETCURSEL, eax, 0    ; if found, we display this item in the combobox
    .ELSE
        Invoke SendMessage, hCbo, WM_SETTEXT, 0, Addr szTextBuffer
        mov eax, -1
        shl eax, 16d
        Invoke SendMessage, hCbo, CB_SETEDITSEL, 0, eax   ; otherwise we set the editbox text of the combobox to the listview text and select all text by defaul
    .ENDIF      
    
    ret

ListViewDropDownContent endp



end start
