include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include comdlg32.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib comdlg32.lib

WinMain				        PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc				        PROTO :DWORD, :DWORD, :DWORD, :DWORD
InitLV                      PROTO :DWORD
LoadLV                      PROTO :DWORD
ListViewDropDownContent     PROTO :DWORD, :DWORD, :DWORD, :DWORD
ListViewDropDownListContent PROTO :DWORD, :DWORD, :DWORD, :DWORD


;--------------------------------------------------------------------------
; TEXT Macro
;--------------------------------------------------------------------------
CTEXT MACRO Text
    LOCAL szText
    .data
    szText byte Text, 0
    .code
    EXITM <offset szText>   
ENDM

LISTVIEWSUBCLASSDATA    STRUCT ; needed for subclassing our listview to allow the ownerdrawn part of the dropdownlist combo
    pListViewOldProc    dd 0
    hParent             dd 0
LISTVIEWSUBCLASSDATA    ENDS


.CONST
;LVCombo.dlg
IDD_DIALOG			EQU 1000
IDC_LV				EQU 1001
IDC_EXIT            EQU 1002

IDM_MENU			equ 10000
IDM_FILE_EXIT		equ 10001
IDM_HELP_ABOUT		equ 10101

IDC_CBO_DD_SUPER_POWER		EQU 2001
IDC_CBO_DDL_AGE			    EQU 2002
IDC_CBO_DDL_SEX			    EQU 2003
IDC_CBO_DD_CLASSROOM		EQU 2004
IDC_CBO_DDL_TEACHER	    	EQU 2005
IDC_CBO_DD_PROGRESS 		EQU 2006

IDC_EDIT                    EQU 2099

IDC_CBO_DT_DOB              EQU 2100






.DATA

ClassName			db 'DLGCLASS',0
AppName				db 'ComboBox in Listview',0
AboutMsg			db 'ComboBox (CBS_DROPDOWN & CBS_DROPDOWNLIST) in Listview example by fearless - 23/10/2011',0

LVSubClass          LISTVIEWSUBCLASSDATA <> ; required for allowing ownerdrawn dropdownlist combo


.data?
hInstance			dd ?
CommandLine			dd ?
hWnd				dd ?
hLV                 dd ?
hCboDD              dd ?

